This website uses cookies to ensure you get the best experience on our website. By using our website you agree on the following Cookie Policy, Privacy Policy, and Terms Of Use
This VBA macro allows to move all suppressed mates to a nominated feature manager folder using SOLIDWORKS API. Macro will create folder if it doesn't exist or move to already existing one.
Macro will also move all unsuppressed mates of the folder if exist.
To configure the folder name, change the value of the FOLDER_NAME variable:
Const FOLDER_NAME AsString = "<Folder Name>"
Const FOLDER_NAME AsString = "SuppressedMates"Dim swApp As SldWorks.SldWorks
Sub main()
Set swApp = Application.SldWorks
Dim swAssy As SldWorks.AssemblyDoc
Set swAssy = swApp.ActiveDoc
IfNot swAssy IsNothingThenDim vSuppMates AsVariant
vSuppMates = GetAllSuppressedMates(swAssy)
IfNot IsEmpty(vSuppMates) ThenDim swFolderFeat As SldWorks.Feature
Set swFolderFeat = swAssy.FeatureByName(FOLDER_NAME)
If swFolderFeat IsNothingThen
InsertMatesIntoNewFolder swAssy, vSuppMates, FOLDER_NAME
ElseDim swFolder As SldWorks.FeatureFolder
Set swFolder = swFolderFeat.GetSpecificFeature2()
vSuppMates = ObjectArrayExcept(vSuppMates, swFolder.GetFeatures())
IfNot IsEmpty(vSuppMates) Then
InsertMatesIntoExistingFolder swAssy, vSuppMates, swFolderFeat
EndIf
MoveUnsuppressedMatesFromFolder swAssy, swFolderFeat
EndIfEndIfElse
MsgBox "Please open assembly"EndIfEndSubSub InsertMatesIntoNewFolder(assm As SldWorks.AssemblyDoc, mates AsVariant, folderName AsString)
Dim swModel As SldWorks.ModelDoc2
Set swModel = assm
If swModel.Extension.MultiSelect2(mates, False, Nothing) = UBound(mates) + 1 ThenSet swFolderFeat = swModel.FeatureManager.InsertFeatureTreeFolder2(swFeatureTreeFolderType_e.swFeatureTreeFolder_Containing)
swFolderFeat.Name = folderName
Else
Err.Raise vbError, "", "Failed to select mates to add to new folder"EndIfEndSubSub InsertMatesIntoExistingFolder(assy As SldWorks.AssemblyDoc, mates AsVariant, folderFeat As SldWorks.Feature)
Dim swLastFeatInFolder As SldWorks.Feature
While folderFeat.GetTypeName2() <> "FtrFolder"Or InStr(folderFeat.Name, "___EndTag___") = 0
Set swLastFeatInFolder = folderFeat
Set folderFeat = folderFeat.GetNextSubFeature
Wend
If swLastFeatInFolder.GetTypeName2() = "FtrFolder"Then
Err.Raise vbError, "", "Not supported. Folder is empty"EndIfDim swModel As SldWorks.ModelDoc2
Set swModel = assy
Dim i AsIntegerFor i = 0 To UBound(mates)
Dim swMateFeat As SldWorks.Feature
Set swMateFeat = mates(i)
'swMoveLocation_e.swMoveToFolder option doesn't work, need to move after last mate in the folderIfFalse = swModel.Extension.ReorderFeature(swMateFeat.Name, swLastFeatInFolder.Name, swMoveLocation_e.swMoveAfter) Then
Err.Raise vbError, "", "Failed to move mate into the folder"EndIfSet swLastFeatInFolder = swMateFeat
NextEndSubSub MoveUnsuppressedMatesFromFolder(assy As SldWorks.AssemblyDoc, folderFeat As SldWorks.Feature)
Dim swModel As SldWorks.ModelDoc2
Set swModel = assy
Dim swFolder As SldWorks.FeatureFolder
Set swFolder = folderFeat.GetSpecificFeature2
Dim vMates AsVariant
vMates = swFolder.GetFeatures
IfNot IsEmpty(vMates) ThenDim i AsIntegerFor i = 0 To UBound(vMates)
Dim swMateFeat As SldWorks.Feature
Set swMateFeat = vMates(i)
IfFalse = swMateFeat.IsSuppressed2(swInConfigurationOpts_e.swThisConfiguration, Empty)(0) ThenIfFalse = swModel.Extension.ReorderFeature(swMateFeat.Name, "", swMoveLocation_e.swMoveToEnd) Then
Err.Raise vbError, "", "Failed to move mate out of the folder"EndIfEndIfNextEndIfEndSubFunction GetAllSuppressedMates(assm As SldWorks.AssemblyDoc) AsVariantDim swSuppMates() As SldWorks.Feature
Dim isInit AsBoolean
isInit = FalseDim vMates AsVariant
vMates = GetAllMates(assm)
IfNot IsEmpty(vMates) ThenDim i AsIntegerFor i = 0 To UBound(vMates)
Dim swMateFeat As SldWorks.Feature
Set swMateFeat = vMates(i)
If swMateFeat.IsSuppressed2(swInConfigurationOpts_e.swThisConfiguration, Empty)(0) ThenIf isInit ThenReDimPreserve swSuppMates(UBound(swSuppMates) + 1)
ElseReDim swSuppMates(0)
isInit = TrueEndIfSet swSuppMates(UBound(swSuppMates)) = swMateFeat
EndIfNextEndIf
GetAllSuppressedMates = swSuppMates
EndFunctionFunction GetAllMates(assm As SldWorks.AssemblyDoc) AsVariantDim swMates() As SldWorks.Feature
Dim isInit AsBoolean
isInit = FalseDim swModel As SldWorks.ModelDoc2
Set swModel = assm
Dim swMateGroupFeat As SldWorks.Feature
Dim featIndex AsInteger
featIndex = 0
DoSet swMateGroupFeat = swModel.FeatureByPositionReverse(featIndex)
featIndex = featIndex + 1
LoopWhile swMateGroupFeat.GetTypeName2() <> "MateGroup"Dim swMateFeat As SldWorks.Feature
Set swMateFeat = swMateGroupFeat.GetFirstSubFeature
WhileNot swMateFeat IsNothingIfTypeOf swMateFeat.GetSpecificFeature2() Is SldWorks.Mate2 ThenIf isInit ThenReDimPreserve swMates(UBound(swMates) + 1)
ElseReDim swMates(0)
isInit = TrueEndIfSet swMates(UBound(swMates)) = swMateFeat
EndIfSet swMateFeat = swMateFeat.GetNextSubFeature
Wend
GetAllMates = swMates
EndFunctionFunction ObjectArrayExcept(mainArr AsVariant, except AsVariant) AsVariantDim retVal() AsObjectDim isInit AsBooleanDim i AsIntegerFor i = 0 To UBound(mainArr)
Dim item AsObjectSet item = mainArr(i)
IfNot ObjectArrayContains(except, item) ThenIf isInit ThenReDimPreserve retVal(UBound(retVal) + 1)
ElseReDim retVal(0)
isInit = TrueEndIfSet retVal(UBound(retVal)) = item
EndIfNextIf isInit Then
ObjectArrayExcept = retVal
Else
ObjectArrayExcept = Empty
EndIfEndFunctionFunction ObjectArrayContains(arr AsVariant, item AsObject) AsBooleanDim i AsIntegerFor i = 0 To UBound(arr)
If arr(i) Is item Then
ObjectArrayContains = TrueExitFunctionEndIfNext
ObjectArrayContains = FalseEndFunction
Notifications
Join session by SOLIDWORKS and PDM API expret Artem Taturevych at 3DEXPERIENCE World 2025 on Feb 26 at 08:30 AM CST to explore 10 essential macros for automating drawings, assemblies, custom properties, and more